//+------------------------------------------------------------------+
//|                                                     5matf.mq4 |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011"
#property link      ""

#import "5MATL v2b.ex4"
   int Sub_5MATL(int argTimeFrame1, int argTimeFrame2, int argTimeFrame3, 
                  int argTrendPeriod1, int argTrendPeriod2, int argTrendPeriod3, int argTrendPeriod4, int argTrendPeriod5,
                  int argPrice, int argMa_Method, bool Display, string argFormName = "" );
#import "drawing.ex4" 
 void Delete_Label(string name);
 void Create_Label(int x, int y, string name,string windowname);
#include <stdlib.mqh>
#import "stdlib.ex4"
  string ErrorDescription(int error_code); 
 
string ExpertName ="5MATL EA v2b";

extern bool    ECNBroker      = true; 
extern double  StopLoss       = 15;
extern double  TakeProfit     = 25;
extern double  TrailingStop   = 10;
extern double  Lots           = 0.1;
extern int     Slippage       = 3;
extern int     MagicNumber    = 58132134;
extern int     OpenLevel      = 0;
extern int     CloseLevel     = 1;
extern int     TimeFrame1     = 5;
extern int     TimeFrame2     = 30;
extern int     TimeFrame3     = 60;
extern int     TrendPeriod1   = 5;
extern int     TrendPeriod2   = 8;
extern int     TrendPeriod3   = 13;
extern int     TrendPeriod4   = 21;
extern int     TrendPeriod5   = 34;
extern int     Price          = 0;
extern int     Ma_Method      = 0; 
extern bool    Display        = true; 
int Signal;
double SL,TP,point = 0;

int init()
{
   if(OpenLevel<0) OpenLevel=-OpenLevel;
   if(CloseLevel<0) CloseLevel=-CloseLevel;

   Create_Label(5,12,"EAName","");
   ObjectSetText("EAName",ExpertName, 11, "Ariel Black", White);  

   double pipMultiplier = 1;
   if (Digits==3 || Digits==5) 
         pipMultiplier = 10;
   else  pipMultiplier = 1;
                  
   point = Point*pipMultiplier;
   StopLoss=point*StopLoss;
   TakeProfit=point*TakeProfit;
   TrailingStop=point*TrailingStop;
   Slippage=point*Slippage;
     
   if(TimeFrame1!=Period())
      {    
       Alert("***First Time Frame is different from Chart Period. TimeFrame1="+TimeFrame1+", Chart Period=",Period());
       Alert("***Setting TimeFrame1 to Period");
       TimeFrame1=Period();
       }
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
   Delete_Label("EAName");
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{         
Signal= Sub_5MATL(TimeFrame1,TimeFrame2,TimeFrame3,TrendPeriod1,TrendPeriod2,TrendPeriod3,TrendPeriod4,TrendPeriod5,Price,Ma_Method,Display,"" );
//Print("Signal = ",Signal);
//Print("Window Size ","X=",WindowXOnDropped()," Y=",WindowYOnDropped());
int Total=0;
for(int cnt=0;cnt<OrdersTotal();cnt++)
   {
   OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
   if(OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber )
      {
      Total++;
            if(OrderType()==OP_BUY)
         {
         if(Signal<-CloseLevel)
            {
            OrderClose(OrderTicket(),OrderLots(),Bid,Slippage);
            return(0);
            }
          if(TrailingStop>0 &&(OrderStopLoss()==0 ||         
            (Bid-OrderOpenPrice()>TrailingStop && OrderStopLoss()<Bid-TrailingStop)))
               {
               OrderModify(OrderTicket(),OrderOpenPrice(),Bid-TrailingStop,OrderTakeProfit(),0);
               int ErrorCode=Check_TicketError(OrderTicket(),"Trailing Stop, Order Open, Ordertype="+OrderTicket());
               return(0);
               }
         }
      if(OrderType()==OP_SELL)
         {
         if(Signal>CloseLevel)
            {
            OrderClose(OrderTicket(),OrderLots(),Ask,Slippage);
            return(0);
            }         
         if(TrailingStop>0 &&(OrderStopLoss()==0 ||
            (OrderOpenPrice()-Ask>TrailingStop && OrderStopLoss()>Ask+TrailingStop)))
               {
               OrderModify(OrderTicket(),OrderOpenPrice(),Ask+TrailingStop,OrderTakeProfit(),0);
               ErrorCode=Check_TicketError(OrderTicket(),"TrailingStop, Order Open, Ordertype="+OrderType());
               return(0);
               }
         }
      }
   }
if(Total==0)
   {
   if(Signal>OpenLevel)
      {
      
      SL=0;TP=0;
      if(StopLoss>0)   SL=Ask-StopLoss;
      if(TakeProfit>0) TP=Ask+TakeProfit;
      
      Place_Order(OP_BUY,Lots,Ask,Slippage,SL,TP,ExpertName,Green);
      return(0);
      }
      
   if(Signal<-OpenLevel)
      {
      
      SL=0;TP=0;
      if(StopLoss>0)   SL=Bid+StopLoss;
      if(TakeProfit>0) TP=Bid-TakeProfit;
      
      Place_Order(OP_SELL,Lots,Bid,Slippage,SL,TP,ExpertName,Green);   
      return(0);
      }
   }
  return(0);
}

int Place_Order(int argOrderType, double argLots, double argPrice, int argSlippage,double argSL, double argTP, string argComment, color argColor )
{
   int Ticket,ErrorCode;
   if (!ECNBroker)
              {
   		       Ticket=OrderSend(Symbol(),argOrderType,argLots,argPrice,argSlippage,argSL,argTP,argComment,MagicNumber,0,argColor);	
   		       ErrorCode=Check_TicketError(Ticket,"NonECN, Order Open, Ordertype="+argOrderType);
   		     }  
          else 
             {
                Ticket=OrderSend(Symbol(),argOrderType,argLots,argPrice,argSlippage,0.0,0.0,argComment,MagicNumber,0,argColor);
                ErrorCode=Check_TicketError(Ticket,"ECN, Order Open, Ordertype="+argOrderType);
                if (Ticket >= 0)
                     {
                     OrderModify(Ticket,OrderOpenPrice(),argSL,argTP,0,CLR_NONE);
                     ErrorCode=Check_TicketError(Ticket,"ECN initial SL TP, Order Open, Ordertype="+argOrderType);
                     }
             }		  
                  
      return(0);
}
int Check_TicketError(int TicketNumber, string argComment) 
{
   int ErrorCode=0;
   if(TicketNumber == -1)
			{
         ErrorCode = GetLastError();
		  	string ErrAlert = StringConcatenate("Open Error> " + argComment +" - Error ",ErrorCode,": ",ErrorDescription(ErrorCode), " Bid: ",Bid," Ask: ",Ask," ",StopLoss);
			Alert(ErrAlert);
			Print(ErrAlert);
			}
	return(ErrorCode);
}
//+------------------------------------------------------------------+

//+-----------