//Version  October 1 , 2006     
//+------------------------------------------------------------------+
//|                                                 4c_Parabolic.mq4 |
//|                               Copyright  2006, Nikolay Kositsin | 
//|                                Khabarovsk, farria@mail.redcom.ru | 
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Nikolay Kositsin"
#property link      "farria@mail.redcom.ru"
#property indicator_chart_window 
#property indicator_buffers 4
#property indicator_color1 Yellow 
#property indicator_color2 Magenta
#property indicator_color3 Lime 
#property indicator_color4 Red
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 3 
#property indicator_width4 3

extern double       Step = 0.025;
extern double    Maximum = 0.25;
extern int TrendMinimum = 5; 

double UpBuffer1[];
double DnBuffer1[];
double UpBuffer2[];
double DnBuffer2[];
double SarBuffer[];

int bar;
double dT_min,low,low1,high,high1,SAR,ABS_trend,SAR1;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() 
{  
IndicatorBuffers(5);
SetIndexBuffer(0,UpBuffer1); 
SetIndexBuffer(1,DnBuffer1); 
SetIndexBuffer(2,UpBuffer2);
SetIndexBuffer(3,DnBuffer2); 
SetIndexBuffer(4,SarBuffer);

SetIndexStyle(0,DRAW_ARROW); 
SetIndexStyle(1,DRAW_ARROW); 
SetIndexStyle(2,DRAW_ARROW); 
SetIndexStyle(3,DRAW_ARROW); 
SetIndexArrow(0,158); 
SetIndexArrow(1,158); 
SetIndexArrow(2,158); 
SetIndexArrow(3,158); 

SetIndexEmptyValue(0,0.0);
SetIndexEmptyValue(1,0.0);
SetIndexEmptyValue(2,0.0);
SetIndexEmptyValue(3,0.0);

IndicatorShortName ("Parabolic( Step="+Step+", Maximum="+Maximum+")"); 
SetIndexLabel (0, "lower_Up_Trend");
SetIndexLabel (1, "lower_Down_Trend"); 
SetIndexLabel (2, "Up_Trend");
SetIndexLabel (3, "Down_Trend"); 

IndicatorDigits(Digits);

dT_min=TrendMinimum*Point;

return(0); 
} 
//+------------------------------------------------------------------+
//| 4c_Parabolic                                                     |
//+------------------------------------------------------------------+
int start()
{
if(Bars-1<2) return(0);

int MaxBar,limit,counted_bars=IndicatorCounted();

if (counted_bars<0)return(-1);

if (counted_bars>0) counted_bars--;

MaxBar=Bars-1;
limit=MaxBar-counted_bars;
if (limit>MaxBar-1){limit=MaxBar-1; SarBuffer[MaxBar]=0; }
//----
for (bar=limit;bar>=0;bar--)
   {
     SarBuffer[bar]=iSAR(NULL,0,Step,Maximum,bar);
     //----  
     SAR=SarBuffer[bar];
     SAR1=SarBuffer[bar+1];
     
     low=Low[bar];
     high=High[bar];
     low1=Low[bar+1];
     high1=High[bar+1];
     
     Ind_SAR();
     
     if((SAR1>=high1)&&(SAR<high)&&(SAR>low )){SAR=low-Point ;SarBuffer[bar]=SAR;Ind_SAR();}
     if((SAR1<=low1 )&&(SAR>low )&&(SAR<high)){SAR=high+Point;SarBuffer[bar]=SAR;Ind_SAR();}
   }
//----
return(0);
}
//+--------------------------------------------------------------------+
void Ind_SAR()
  {
     UpBuffer1[bar]=0.0;
     DnBuffer1[bar]=0.0;
     UpBuffer2[bar]=0.0;
     DnBuffer2[bar]=0.0; 
     //----  
   
/*     double Ratio =1;
     if((SAR1>=high1 && SAR<=low) || (SAR1<=low1 && SAR>=high))
         Ratio=1.0;
     else   
         {
         if(SAR1 !=0)   
               Ratio=SAR/SAR1;
         else  Ratio=1.;
         }
     SAR=SAR*Ratio;       ///*MathPow(Ratio,2);  
*/     
     if(((SAR>=high)&&(SAR1>=high1))||((SAR<=low)&&(SAR1<=low1)))
               {
               ABS_trend=MathAbs(SAR-SAR1);
               }
     else      ABS_trend=0.0;
     //----
     if(SAR>=high)if(ABS_trend<dT_min)
               DnBuffer1[bar]=SAR;
     else      DnBuffer2[bar]=SAR;
                     
     if(SAR<=low )if(ABS_trend<dT_min) 
                           UpBuffer1[bar]=SAR;
                  else     UpBuffer2[bar]=SAR;
  }